import os
import bs4
import csv
import json

#-------------------------------------------------------------------------#

def VratiNajboljegStudenta(filename):
    jsonFile = open(filename)
    jsonData = json.loads(jsonFile.read())

    studenti = jsonData['studenti']

    prosek      = 0
    MaxProsek   = 0
    MaxIme      = None
    MaxIndeks   = None

    for student in studenti:
        ocene = student['ocene']
        prosek = sum(ocene) / len(ocene)

        imePrezime = student['ime'] + " " + student['prezime']
        Indeks = str(student['indeks']) + "\\" + str(student['godina'])
         
        if(prosek > MaxProsek):
            MaxProsek = prosek
            MaxIme = imePrezime
            MaxIndeks = Indeks    

    grupa = filename.split(".")[0].split("\\")[1]
    
    return{
        "Ime Prezime": MaxIme,
        "Indeks": MaxIndeks,
        "Prosek": MaxProsek,
        "Grupa":  grupa      
    }

#-------------------------------------------------------------------------#

if(not os.path.exists("FajloviZaDekana")):
    os.mkdir("FajloviZaDekana")

folderSaSpiskovima = "spiskovi"
mikaCSV = open("FajloviZaDekana\\mika.csv","w",newline='')

polja = ['Ime Prezime','Indeks','Prosek','Grupa']
writer = csv.DictWriter(mikaCSV,fieldnames = polja)
writer.writeheader()

for folderName,subfolders,filenames in os.walk(folderSaSpiskovima):
    for filename in filenames:
        if(filename.endswith(".json")):
            writer.writerow(VratiNajboljegStudenta(folderSaSpiskovima + "\\" + filename))

mikaCSV.close()