import os
import bs4
import csv

#-------------------------------------------------------------------------#

def VratiNajboljegStudenta(filename):
    xml = open(filename)
    soup = bs4.BeautifulSoup(xml, features = "html.parser")
    xml.close()

    suma        = 0
    prosek      = 0
    MaxProsek   = 0
    MaxIme      = None
    MaxIndeks   = None
    
    studenti = soup.select("student")

    for student in studenti:
        
        imePrezime = student.find("ime").get_text() + " " + student.find("prezime").get_text()
        indeks = student.get("indeks") + "\\" + student.get("godina")

        OCENE = student.find("ocene")
        ocene = OCENE.select("ocena")

        for ocena in ocene:
            suma += int(ocena.get_text())
        
        prosek = suma / len(ocene)

        if(prosek > MaxProsek):
            MaxProsek = prosek
            MaxIme = imePrezime
            MaxIndeks = indeks
        
        suma    = 0
        prosek  = 0    

    grupa = filename.split(".")[0].split("\\")[1]
    
    return{
        "Ime Prezime": MaxIme,
        "Indeks": MaxIndeks,
        "Prosek": MaxProsek,
        "Grupa":  grupa      
    }

#-------------------------------------------------------------------------#

if(not os.path.exists("FajloviZaDekana")):
    os.mkdir("FajloviZaDekana")

folderSaSpiskovima = "spiskovi"
peraCSV = open("FajloviZaDekana\\pera.csv","w",newline='')

polja = ['Ime Prezime','Indeks','Prosek','Grupa']
writer = csv.DictWriter(peraCSV,fieldnames = polja)
writer.writeheader()

for folderName,subfolders,filenames in os.walk(folderSaSpiskovima):
    for filename in filenames:
        if(filename.endswith(".xml")):
            writer.writerow(VratiNajboljegStudenta(folderSaSpiskovima + "\\" + filename))

peraCSV.close()